; "dir" is a directory browse program, it returns results as?
;  
%define stdout 0x1
%define stderr 0x2
	
 [section .text]

global	_start

_start:
main:
  call	setup_terminal

  pop	ecx			;get parameter count
  pop	esi			;get pointer to program name
  mov	[prog_name_ptr],esi
;
; move through parameters till enviro ptrs
;
find_env:			;move forward to
  pop	eax			; stack env pointers
  or	eax,eax
  jnz	find_env
  mov	[enviro_ptrs],esp
;
; find our path to executable & default directory path
;  
  call	find_paths		;in [prog_name_ptr], [enviro_ptrs]

; setup to read keyboard and mouse

blp1:
  call	read_directory

  mov	eax,sort_pointers
  mov	[page_top_ptr],eax	;setup top of page for display
  mov	[select_ptr],eax	;initialize selection pointer
  mov	byte [select_ptr_row],1	;put pointer on line 1

  call	format_for_sort
  call	get_file_types
  call	sort_files
blp2:
  call	find_highlighted_entry
  call	display_dir
  call	display_status

  mov	esi,status_msg3		;prompt message
  mov	edi,file_path		;buffer for data
  mov	eax,40            	;max length of string
  mov	byte [str_terminator],0 ;allow both "esc" and "rtn" as terminators
  mov	byte [edi],0
  call	get_string

  cmp	byte [kbuf],-1
  jne	key_event			;jmp if key pressed
  call	mouse_event
  jmp	blp2
key_event:
  cmp	byte [kbuf+1],0
  je	single_key
;
; check for arrow keys
;
  mov	al,[kbuf+2]
  cmp	al,41h
  je	up_key
  cmp	al,42h
  je	down_key
  cmp	al,43h
  je	right_key
  cmp	al,44h
  je	left_key
  cmp	al,36h
  je	pgdn
  cmp	al,35h
  je	pgup  
  jmp	blp2				;ignore all others
up_key:
  call	up
  jmp	blp2
down_key:
  call	down
  jmp	blp2
right_key:
  mov	edi,[select_ptr]	;get pointer to array of pointers
  mov	edi,[edi]		;get current pointer
  cmp	byte [edi],1
  jne	blp2      		;exit if not directory
  inc	edi			;move past code
  mov	esi,default_path
  call	build_path
  mov	byte [edi-1],'/'	;append "/" to end of filepath
  mov	byte [edi],0  
  jmp	blp1  
left_key:
  call	left
  jmp	blp1
single_key:
  mov	al,[kbuf]			;get keypress
  cmp	al,1bh
  je	escape_pressed
  cmp	al,0dh
  je	return_pressed
blp2j:
  jmp	blp2				;ignore other keys

pgdn:
  call	page_down
  jmp	blp2
pgup:
  call	page_up
  jmp	blp2

;
; return null filename, (buffer read)
;
escape_pressed:
  mov	ebx,out_file_name
  mov	esi,0			;lenght of data to write
  mov	edi,file_path		;data pointer
  call	write_file
  jmp	browser_exit

out_file_name	db	'a.out~',0
;
; return selected file, either typed name or highlighted file
;
return_pressed:
  mov	edi,file_path
  cmp	byte [edi],0
  jne	file_typed
  mov	edi,[select_ptr]
  mov	edi,[edi]
  cmp	dword [edi],002e2e01h		;check if . entry
  je	escape_pressed			;jmp if . entry (treat as esc)
  cmp	byte [edi],3			;check if code for file
  jne	blp2j				;jmp if illegal selecton
  inc	edi
  mov	esi,default_path
  call	build_path
  mov	edi,default_path
file_typed:
  mov	esi,edi
  xor	ecx,ecx
ft_lp:
  lodsb
  inc	ecx
  or	al,al
  jnz	ft_lp				;compute lenght of write data
  mov	esi,ecx				;lenght to esi
  mov	ebx,out_file_name
  call	write_file
;
; write output file
;
browser_exit:	
	mov	ecx,0x5402			;set termios
	mov	edx,oldtermios
	call	do_ioctl			;restore termios


	mov	eax,1
	mov	ebx,0			;normal exit
	int	0x80			;exit
;------------------------------------------------------------------
; up key pressed
;
up:
  mov	eax,[select_ptr]
  cmp	eax,sort_pointers
  je	up_exit			;jmp if at top
  mov	bl,[select_ptr_row]
  cmp	bl,1			;cursor at top
  je	scroll_up
;
; cursor inside window, and select_ptr not at top of list
;
  dec	bl
  mov	[select_ptr_row],bl
  sub	eax,4
  mov	[select_ptr],eax
  jmp	up_exit
;
; cursor at top of screen and select_ptr not at top of list
;
scroll_up:
  sub	eax,4			;move cursor up 1
  mov	[select_ptr],eax
  mov	[page_top_ptr],eax	;move widow up 1
up_exit:
  ret

;------------------------------------------------------------------
; down key pressed
;
down:
  mov	eax,[select_ptr]
  cmp	dword [eax+4],0		;check if at end of ptr list
  je	down_exit		;exit if at end of list
  mov	bl,[select_ptr_row]
  mov	bh,[window_rows]
  sub	bh,3			;compute last display line
  cmp	bl,bh			;is cursor on last line
  je	down_10			;jmp if cursor on last line
;
; we are not at end of pointers and not on last line
;
  inc	bl			;move cursor down
  mov	[select_ptr_row],bl
  add	eax,4
  mov	[select_ptr],eax
  jmp	down_exit
;
; cursor on last line, and more pointers are available
;
down_10:
  add	eax,4
  mov	[select_ptr],eax
  mov	eax,[page_top_ptr]
  add	eax,4
  mov	[page_top_ptr],eax
down_exit:
  ret
;------------------------------------------------------------------
; left arrow key pressed, truncate the  end of default_path
;  path is of form: (xxx/yyyy/zzz)
left:
  mov	esi,default_path
left_10:
  lodsb
  or	al,al
  jnz	left_10			;scan to end of path
left_12:
  dec	esi			;move back to zero
  cmp	byte [esi],"/"
  jne	left_12			;find ending '/'
  dec	esi			;move back to '/'
left_20:
  cmp	esi,default_path
  je	left_40			;jmp if at beginning of path
  ja	left_30			;jmp if not at beginning of path
  inc	esi			;move to start of default_path
  jmp	left_40			;go create "/",0
left_30:
  dec	esi
  cmp	byte [esi],'/'
  jne	left_20			;scan back one entry
  call	save_old_path
left_40:
  mov	byte [esi+1],0		;truncate path
  ret
;----------------------------------------
;
find_highlighted_entry:
  cmp	byte [old_path],0	;check if old path needs highlighting
  je	highlight_selected	;jmp if no old_path to highlight
;
; search for old path and set as "selected"
;
  mov	ebp,sort_pointers
  mov	[page_top_ptr],ebp
  mov	ecx,1			;for column tracking
try_again:
  mov	esi,[ebp]		;get next pointer
  inc	esi			;move past code
  mov	edi,old_path
cmp_loop:
  mov	al,[esi]
  or	al,[edi]
  jz	ds_match		;jmp if match found
  cmpsb
  jne	ds_next			;jmp if this entry does not match
  jmp	cmp_loop
ds_next:
  add	ebp,4
  inc	ecx
  cmp	dword [ebp],0
  jne	try_again
  jmp	no_match
ds_match:
  xor	ebx,ebx
  mov	bl,[window_rows]
  sub	ebx,3			;compute size of window
  cmp	ecx,ebx
  jbe	ds_set_selector
  sub	ecx,ebx
  shl	ebx,2
  add	[page_top_ptr],ebx	;adjust page top ptr
  jmp	ds_match
ds_set_selector:
  mov	[select_ptr],ebp	;set new select ptr
  mov	[select_ptr_row],cl	;set new row
no_match:
  mov	byte [old_path],0	;disable old path till next left arrow
highlight_selected:
  ret
;----------------------------
save_old_path:
  push	esi
  mov	edi,old_path
  inc	esi		;move past '/'
sop_10:
  lodsb
  stosb
  cmp	al,'/'
  je	sop_20		;jmp if end of name
  or	al,al
  jnz	sop_10
sop_20:
  mov	byte [edi-1],0	;force zero at end
  pop	esi
  ret
;----------------------------
page_up:
  xor	ecx,ecx
  mov	cl,[window_rows]
  sub	cl,3
  mov	esi,[page_top_ptr]
pu_loop:
  cmp	esi,sort_pointers
  je	pu_set			;jmp if at top
  sub	esi,4			;move up
  dec	cl
  jnz	pu_loop			;loop if page incomplete
pu_set:
  mov	[page_top_ptr],esi
  mov	[select_ptr],esi
  mov	byte [select_ptr_row],1
  ret
  
;----------------------------
page_down:
  mov	cl,[window_rows]
  sub	cl,3
  mov	esi,[page_top_ptr]
pd_loop:
  cmp	dword [esi+4],0
  je	pd_set			;jmp if end of data found
  add	esi,4
  dec	cl
  jnz	pd_loop			;loop till end of page found
pd_set:
  mov	[page_top_ptr],esi
  mov	[select_ptr],esi
  mov	byte [select_ptr_row],1
  ret

;----------------------------
; write temp files
;  input: ebx =  file name string ptr
;         edi =  file data ptr
;         esi =  file length
;
PERMS equ 644q
O_WRONLY_CREAT_TRUNC equ 1101q

write_file: 
  mov ecx,O_WRONLY_CREAT_TRUNC
  mov edx,PERMS
  mov al,5
  int	80h
;;  call OpenFile
;  js wfth_error
  mov	ebx,eax			;move file descriptor to ebx
  mov	ecx,edi
  mov	edx,esi			;get file lenght
  mov al,4
  int	80h
;  call Write_File
;  js wfth_error
;  push byte ERRNOIO
;  pop dword[ErrNr]
;  cmp eax,edx
;  jnz wfth_error
  mov al,6
  int	80h
;  call CloseFile
;  js wfth_error
  ret
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; input: esi = prompt message
;        edi = string buffer
;        status_color = color for prompt
;        status_color1 = color for input data
;        eax = max string length (single char strings return after char typed)
;        str_terminator (byte) = <esc> or <return> or 0 for either
; output: ecx = 0-got it  1-mouse  2-abort
;         eax = string length
;         str_begin = pointer to string text (part of prompt line)
; data: str_begin, str_ptr, str_max, str_cursor
;
get_string:
  cld
  mov	dword [str_max_count],eax
  mov	[str_ptr],edi
  mov	[str_begin],edi		;save pointer to string buffer

  sub	ecx,ecx
  mov	cl,[window_columns]
  add	ecx,screenline		;compute length of prompt line
  mov	edi,screenline
gs_l:
  movsb				;move message to buffer
  cmp	byte [esi],0
  jne	gs_l
;
; move current contents of buffer to display
;
  mov	esi,[str_ptr]
gs_2:
  cmp	byte [esi],0
  je	gs_3			;exit if string moved
  movsb
  jmp	gs_2
gs_3:
  mov	[str_ptr],esi		;point at end of string

  mov	eax,[str_max_count]	;restore max string length  
  add	eax,[str_begin]
  mov	[str_max],eax		;sav max str ptr

  mov	eax,edi
  sub	eax,screenline		;compute cursor
  add	al,[window_indent]
  mov	ah,[window_rows]
  add	al,1			;compute cursor location for entry
  mov	dword [str_cursor],eax	;store cursor for beginning of string

  mov	al,' '
gs_4:
  stosb				;clear end of prompt line
  cmp	edi,ecx
  jb	gs_4

  mov	byte [edi],0		;put zero at end  
  mov	dword [edi-8],'ESC='
  mov	dword [edi-4],'done'
    
  mov	eax,[status_color]	;get color (change to status_color)
  mov	bh,[window_rows]
  mov	bl,[window_indent]	;column 
  mov	ecx,screenline 		;get msg address
  call	display_color_at	;display message

gs_lpp:
  mov	eax,[str_cursor]
  call	move_cursor		;move cursor (ah=row al=column)
  call	read_keys		;fill kbuf
  cmp	byte [kbuf],-1
  jne	got_key			;jmp if keyboard action
; ignore mouse buttons
  jmp	gs_end			;exit if mouse
got_key:
  mov	esi,kbuf
  mov	al,byte [esi]
  mov	ah,byte [str_terminator]	;
  cmp	al,ah			;check if terminator character
  je	gs_05			;jmp if end of input
  cmp	ah,0			;check if both "esc" and "rtn" terminators
  jne	gs_10			;jmp if single terminator in str_terminator
  cmp	al,1bh			;check for escape
  je	gs_05			;jmp if escape
  cmp	al,0dh
  jne	gs_10			;jmp if not end of data
gs_05:
  cmp	byte [esi+1],0
  je	gs_donej		;jmp if escape
  jmp	gs_end			;jmp if multibyte char
gs_donej:
  jmp	gs_done
gs_10:
  cmp	al,0dh
  jne	gs_12			;jmp if not <enter>
  mov	al,0ah			;substutite 0a for 0d
  jmp	gs_16			;jmp if <enter>
gs_12:
  cmp	al,7fh			;check for rubout
  jne	gs_14			;jmp if not rubout
; process rubout here
  mov	edi,[str_ptr]
  cmp	edi,[str_begin]
  je	gs_lpp			;ignore rubout if at start of string
  dec	edi
  mov	byte [edi],20h		;rubout character
  mov	dword [str_ptr],edi
  dec	dword [str_cursor]
  mov	cl,20h			;get char to display
  mov	eax,[status_color]	;get display color
  mov	ebx,[str_cursor]	;get display location  
  call	display_char_at
gs_ignore1:
  jmp	gs_lpp			;try again
gs_14:
  cmp	al,03h			;check for ctrl-c
  je	gs_abort		;jmp if abort
gs_15:
  cmp	al,09h			;check for tab
  je	gs_16			;jmp if tab
gs_15a:
  cmp	al,20h
  jb	gs_ignore		;jmp if non-alpha
  cmp	al,7eh
  ja	gs_ignore		;jmp if non-alpha
gs_16:
  mov	edi,[str_ptr]
  cmp	edi,[str_max]		;check if room
  jae	gs_ignore		;ignore char if out of room
  mov	byte [edi],al		;store char
; display string
  mov	cl,al			;get char to display
  mov	eax,[status_color]	;get display color
  mov	ebx,[str_cursor]	;get display location  
  call	display_char_at
  mov	eax,[str_ptr]
  cmp	eax,[str_max]
  je	gs_ignore		;skip update if at end of entry area
  inc	dword [str_ptr]
  inc	dword [str_cursor]
gs_ignore:
  cmp	dword [str_max_count],1
  je	gs_done1		;exit if single char. entry
  jmp	gs_lpp
gs_abort:
  mov	ecx,2
  jmp	gs_end
gs_done1:
gs_done:
  sub	ecx,ecx
  mov	eax,[str_ptr]
  mov	byte [eax],0		;terminate string
  sub	eax,[str_begin]
  jnz	gs_end
  mov	cl,2
gs_end:
  ret  
;--------------------------------------------------------------
; read one key
;  input:
;  output: kbuf - has character, can be multiple character
;
read_keys:
  mov	ecx,kbuf
pk_10:
  mov	edx,1				;read one key
  mov	eax,3				;sys_read
  mov	ebx,0				;stdin
  int	0x80
;;  js	kr_exit1			;exit if error
  add	ecx,eax			;move buffer pointer
  push	ecx

  mov	eax,168			;poll
  mov	ebx,poll_tbl
  mov	ecx,1			;one structure at poll_tbl
  mov	edx,1			;wait 100 ms
  int	80h
  test	byte [poll_rtn],1
  pop	ecx
  jnz	pk_10
kr_exit1:
  mov	byte [ecx],0		;terminate string
;-----------------------
; format mouse data
;   input: kbuf has mouse escape sequenes
;          1b,5b,4d,xx,yy,zz
;            xx - 20=left but  21=middle 22=right 23=release
;            yy - column+20h
;            zz - row + 20h
;  output: kbuf = ff,button,column,row  
;
mouse_check:
  cmp	word [kbuf],5b1bh		;check if possible mouse
  jne	mc_exit				;jmp if not mouse
  cmp	byte [kbuf+2],4dh
  jne	mc_exit			;jmp if not mouse
; read release key
  mov	eax,3				;sys_read
  mov	ebx,0				;stdin
  mov	ecx,kbuf+6
  mov	edx,20				;buffer size
  int	0x80				;read key
; format data
  mov	edi,kbuf
  mov	byte [edi],-1
  inc	edi			;signal mouse data follows
  mov	al,[kbuf+3]
  and	al,3
  stosb 			;store button 0=left 1=mid 2=right
  mov	al,[kbuf+4]
  sub	al,20h
  stosb				;store column 1+
  mov	al,[kbuf+5]
  sub	al,20h
  stosb				;store row
mc_exit:
  ret 
;
;--------------------------------------------------------------
; process mouse click
;
mouse_event:
  ret

;--------------------------------------------------------------
; move raw data in dbuf to sort_buf and add pointer to
; sort_pointers
;
format_for_sort:
  cld
  mov	edx,dbuf
  mov	edi,sort_buf
  mov	ebp,sort_pointers
  xor	ebx,ebx			;clear for later

ffs_loop1:
  cmp	dword [edx+4],0		;check if offset zero
  je	ffs_done		;jmp if done
  cmp	word [edx+8],0
  je	ffs_done		;jmp if record length zero
  mov	esi,edx			;get pointer to this entry
  add	esi,8			;move past inode and offset
  mov	bx,[esi]		;get length of this record
  add	esi,2			;move forward to filename
  cmp	byte [esi],'.'
  jne	ffs_ok			;jmp if not possible header entry
  cmp	byte [esi+1],0
  je	ffs_next		;skip this "." header entry
;  cmp	byte [esi+1],'.'
;  jne	ffs_ok			;jmp if not possible header entry
;  cmp	byte [esi+2],0
;  je	ffs_next		;skip this ".." header entry
ffs_ok:
  mov	dword [ebp],edi		;store pointer
;
; move the name to sort_buf
;
  mov	al,3
  stosb 			;store code (say it is file for now)
ffs_loop2:
  lodsb
  stosb
  or	al,al
  jnz	ffs_loop2		;move the filename
  add	ebp,4			;move to next pointer store point
ffs_next:
  add	edx,ebx			;move to next record
  jmp	ffs_loop1
ffs_done:
  xor	edx,edx
  mov	[ebp],edx		;terminate pointers, last=0
  ret
;--------------------------------------------------------------
; buffer sort_buf now has code,asciiz file.
; sort_pointers has dword pointer to sort_buf entries.
; call kernel and get code describing each file
;
get_file_types:
  mov	ebp,sort_pointers
gft_loop1:
  cmp	dword [ebp],0
  je	gft_done		;jmp if end of pointers
  mov	edi,[ebp]		;get filename
  inc	edi			;move past code
  mov	esi,default_path
  call	build_path
  mov	ebx,default_path
  mov	ecx,fstat_buf
  mov	eax,107			;fstat
  int	80h
  or	eax,eax
  js	gft_err			;jmp if file not found
;
; decode file type
;
  mov	ax,0f000h
  and	ax,[stmode]
  mov	al,3
  cmp	ah,80h
  je	gft_store		;jmp if regular file
  mov	al,2
  cmp	ah,0a0h
  je	gft_store		;jmp if sym link
  mov	al,1			;assume it is directory
gft_store:
  mov	ebx,[ebp]		;get pointer to name
  mov	[ebx],al		;store code
  add	ebp,4
  jmp	gft_loop1		;loop till done
gft_err:

gft_done:
  ret

;--------------------------------------------------------------
; bubble_sort - sort indexed buffer. 
;  inputs:  ds:0  - ptr to index struc. <word buf_ptr>, <word record_length>
;           es:   - buffer seg,(index has offsets)
;              sort_field_len - length of sort field
;              dx - starting column of sort field
;
;  Output:  index structure is sorted in decending order
;
;  Notes:   The index must have at least one entry.
;           Short or empty records are placed at top of index without
;           attempting to sort.
;
sort_files:
	cld
sn_loop1:
	mov	ebp,sort_pointers
	mov	byte [exchange_flag],0
	mov	ebx,ebp
	add	ebx,4
;
; registers -  ebp - index ptr with lowest name  (esi points at name)
;              ebx - index of challenger         (edi points at challenger name)
;
sn_loop2:
	cmp	dword [ebx],0		;check if done
	je	sn1_done
	mov	esi,[ebp]		;point esi at lowest text string
        mov	edi,[ebx]
        mov	ecx,100			;length of sort
	repe	cmpsb			;check the strings
	jbe	next_challenger
put_on_top:
	mov	eax,[ebp]	;get old lowest
	xchg	eax,[ebx]	;put at challenger's space
	mov	[ebp],eax	;put challenger at top
	mov	byte [exchange_flag],1
next_challenger:
	add	ebx,4
	add	ebp,4
	jmp	sn_loop2
sn1_done:
	cmp	byte [exchange_flag],0
	jne	sn_loop1
sort_exit:	
	ret

;--------------------------------------------------------------
; display directory
;   inputs:  [window_rows] [window_columns]
;            sort_pointers
;
display_dir:
  xor	ecx,ecx
  mov	cl,[window_rows]	;get lines to display
  sub	cl,3			;leave room for status line

  mov	ebp,[page_top_ptr]	;get pointer to first line
;
; move line to screenline
;
  mov	bh,1			;starting display row
dd_lp:
  mov	ch,[window_columns]
  mov	edi,screenline		;get pointer to line build area
  mov	esi,[ebp]		;get pointer to line data
  cmp	esi,0
  je	dd_50			;jmp if out of data
dd_lp2:
  lodsb
  stosb
  cmp	al,0
  je	dd_14			;jmp if end of line found
  dec	ch
  jnz	dd_lp2			;loop till line moved
  jmp	dd_20
dd_14:
  dec	edi				;fill rest of line with blanks
  mov	al,' '
dd_16:
  stosb
  dec	ch
  jnz	dd_16
  mov	byte [edi],0		;put zero at end of line
;
dd_20:
  mov	esi,screenline		;move back start of line
  mov	dl,[esi]		;get code
  mov	eax,[dir_color]
  cmp	dl,1			;check if 
  jne	dd_22			;jmp if not dir
  mov	byte [esi],'/'
  jmp	dd_30
dd_22:
  mov	eax,[link_color]
  cmp	dl,2
  jne	dd_24			;jmp if not link
  mov	byte [esi],'@'
  jmp	dd_30
dd_24:
  cmp	dl,3
  jne	dd_50			;jmp if end of data
  mov	eax,[file_color]
  mov	byte [esi],' '
dd_30:
  push	ebx
  push	ecx
;  mov	bh,1			;row 1
  mov	bl,[window_indent]	;column 
  mov	ecx,screenline		;get display text
  call	display_color_at	;display message
  pop	ecx
  pop	ebx
  add	ebp,4
  inc	bh
  dec	cl
  jz	dd_60			;exit if end of window
  jmp	dd_lp
;
; end of data was reached before end of window, fill rest of screen
;
dd_50:
  mov	edi,screenline
  mov	al,' '
  mov	ch,[window_columns]
dd_52:
  stosb
  dec	ch
  jnz	dd_52
dd_54:
  mov	eax,[file_color]
  push	ecx
  push	ebx
;  mov	bh,1			;row 1
  mov	bl,[window_indent]	;column 
  mov	ecx,screenline		;get display text
  call	display_color_at	;display message
  pop	ebx
  pop	ecx
  inc	bh
  dec	cl
  jnz	dd_54			;exit if end of window

dd_60:
  ret

;----------------------------------------------------------------------
; display status line
;  inputs: select_ptr - pointer to file pointers for current selection
;          select_ptr_row - current row of select ptr
;          window_rows, window_columns
;
display_status:
  mov	ebp,[select_ptr]	;setup to highlight selected file
  mov	ecx,[ebp]		;get message
  mov	eax,[select_color]
  mov	bh,[select_ptr_row]	;row
  mov	bl,[window_indent]	;column
  add	bl,1			;column + 1
  call	display_color_at	;display message/ highlight selection
;
; display status line 1
;
  mov	esi,status_msg1
  call	fill_screenline
  mov	bh,[window_rows]	;row
  sub	bh,2			;move to first row of status
  mov	bl,[window_indent]	;column 
  mov	eax,[status_color]
  call	display_color_at	;display message/ highlight selection
;
; display status line 2
;
  mov	esi,status_msg2
  call	fill_screenline
  mov	bh,[window_rows]	;row
  sub	bh,1			;move to first row of status
  mov	bl,[window_indent]	;column 
  mov	eax,[status_color]
  call	display_color_at	;display message/ highlight selection
;
; display status line 3
;

  mov	esi,status_msg3
  call	fill_screenline
  mov	bh,[window_rows]	;row
  mov	bl,[window_indent]	;column 
  mov	eax,[status_color]
  call	display_color_at	;display message/ highlight selection

  ret
;------------------------------------------------------
; fill screenline msg for width of display
;  inputs :esi=msg
;         ; window_columns
;  output: ecx = screenline ptr
;
fill_screenline:
  mov	edi,screenline
  mov	cl,0
fs_10:
 lodsb
  stosb				;move message to screenline
  or	al,al
  jz	fs_15			;jmp if end of msg found
  inc	cl
  cmp	cl,[window_columns]
  jne	fs_10			;loop if not at window edge
fs_15:
  dec	edi
  mov	al,' '
fs_20:
  cmp	cl,[window_columns]
  je	fs_30			;jmp if line filled
  stosb
  inc	cl
  jmp	fs_20			;fill remainder of line with blanks
fs_30:
  mov	ecx,screenline
  ret
;--------------------------
; input - eax = aaxxffbb  (aa-attribute ff-foreground  bb-background)
;   30-black 31-red 32-green 33-brown 34-blue 35-purple 36-cyan 37-grey
;   attributes 0-normal 1-bold 4-underscore 7-inverse
;   (see /src/lib/vttest for color chart) menu > 11 - 4 - 2
;
set_color:
  mov	byte [vcs1],al
  mov	byte [vcs2],ah
  rol	eax,8
  mov	byte [vcs_atr],al
  mov	ecx,vt100_color_str
  call	display_asciiz
  ret  
;--------------------------
; input al = column (1-xx)
;       ah = row    (1-xx)
;
move_cursor:
  push	edi
  push	eax
  aam
  or	ax,3030h
  mov	cx,ax
  pop	eax
  xchg	ah,al
  aam
  or	ax,3030h
  xchg	ax,cx

  xchg	al,ah
  xchg	cl,ch
  call	amove_cursor
  pop	edi
  ret

;---------------------------
; input ax = column (ascii)
;       cx = row (ascii)
;
amove_cursor:
  mov	word [vt_row],cx
  mov	word [vt_column],ax
  mov	ecx,vt100_cursor
  call	display_asciiz
  ret
  
;
;-------------------------------
; input: eax = color (aa??ffbb) attribute,foreground,background
;        bl = column
;        bh = row
;       ecx = message ptr (asciiz)
;
display_color_at:
  push	ecx
  push	ebx
  call	set_color
  pop	eax
  call	move_cursor
  pop	ecx
  call	display_asciiz
  ret
  
;-------------------------------
; input: eax = color (aa??ffbb) attribute,foreground,background
;        bl = column
;        bh = row
;        cl = ascii char
;
display_char_at:
  push	ecx
  push	ebx
  call	set_color
  pop	eax
  call	move_cursor
  pop	ecx

  cmp	cl,20h
  jae	dca_2			;jmp if possible alpha
  mov	cl,'?'
dca_2:
  cmp	cl,7eh
  jbe	dca_4			;jmp if legal alpha
  mov	cl,'?'
dca_4:
  mov	byte [char_out],cl
  mov	ecx,char_out		;display data
  mov eax, 0x4			; system call 0x4 (write)
  mov ebx, stdout		; file desc. is stdout
  mov	edx,1			;write one char
  int 0x80

  ret
  
;-------------------------------
; display_asciiz - output string
;  input: ecx - ponter to string
;
	%define stdout 0x1
	%define stderr 0x2

display_asciiz:
  xor edx, edx
.count_again:	
  cmp [ecx + edx], byte 0x0
  je .done_count
  inc edx
  jmp .count_again
.done_count:	
  mov eax, 0x4			; system call 0x4 (write)
  mov ebx, stdout			; file desc. is stdout
  int 0x80
  ret

;-----------------------------------------------------------
setup_terminal:
	mov	edx,oldtermios
	mov	ecx, 0x5401	;TCGETS
	call	do_ioctl	;get current termios

	mov	ecx,05401h	;get TCGETS
	mov	edx,newtermios	;get copy of termios to modify
	call	do_ioctl

;;	and	dword [c_lflg],0fffffff4h  ;ICANON|ECHO|ISIG
	mov	byte [newtermios+23],1
	and	byte [newtermios+12],0f4h
	and	byte [newtermios+1],0fah

	mov	ecx,0x5402	;TCSETS
	mov	edx,newtermios
	call	do_ioctl

;
; send escape sequence to turn on mouse
;
  mov	ecx,mouse_escape
  call	display_asciiz

  mov ecx,5413h
  mov edx,winsize
  call do_ioctl		;get term rows (al)  term columns (eax)
  mov eax,[edx]
  cmp eax,0x0000FFFF
  jb sd_err
  or eax,eax
  jnz sd_10
sd_err:
  mov eax,0x00500018
;
; setup single window template
;
sd_10:
  mov	[window_rows],al			;save copy of row count
  shr eax,16
  mov	[window_columns],al			;save copy of column count
;
  cmp	al,50
  jb	sd_exit					;jmp if window too small
  sub	al,50
  mov	byte [window_indent],al
  mov	byte [window_columns],50
sd_exit:
  ret

;---------------------------------------------------------------
; read directory at default_path
;
read_directory:
  cld
  mov	ecx,max			;clear buffer
  mov	edi,dbuf		;
  mov	al,0
  rep	stosb

  mov	eax,5			;open
  mov	ebx,default_path
  mov	ecx,200000h		;directory
  int	80h

  mov	ebx,eax
  mov	eax,141
  mov	ecx,dbuf
  mov	edx,max			;buffer max size
  int	80h			;read

  mov	eax,6
  int	80h			;close
  ret
;--------------------------------------------------------------
; find executable path and default path
;  inputs: [enviro_ptrs] ebx = pointer to enviornment
;          [prog_name_ptr] ebp = pointer to our executable name
; output:  executable_path = path of "a" executable
;          default_path = current default path ending with /
;          negative flag set if executable_path not found
;
find_paths:
;
; store default path first
;
  mov	ebx,default_path
  mov	ecx,100
  mov	eax,183
  int	80h
;
; put '/' on end of default path
;
  mov	esi,default_path
fp_02:
  lodsb
  or	al,al
  jnz	fp_02
  mov	byte [esi],al		;put '/',o at end of path
  dec	esi
  mov	byte [esi],'/'
;
; look for executable path
;
  mov	ebx,[enviro_ptrs]
  mov	ebp,[prog_name_ptr]
  mov	esi,ebp			;get program name ptr in esi
  mov	edi,executable_path
;
; check if our executable has a '/' somewhere in it.
;
fp_05:
  lodsb  
  cmp	al,'/'			;check if file has path
  je	fp_07			;jmp if path provided
  cmp	al,0
  je	fp_10			;jmp if our name dose not have path info
  jmp	short fp_05    
fp_07:
  mov	esi,ebp			;get pointer to our name/path
fp_lp1:
  lodsb
  stosb
  cmp	al,0
  jne	fp_lp1			;loop till name moved
  jmp	fp_exit

; scan the enviornment for PATH entry
  
fp_10:
  or	ebx,ebx
  jz	fp_50
	mov esi,[ebx]
        or	esi,esi
	jz	near fp_50
	cmp [esi],dword 'PATH'
	jne fp_12
	cmp [esi+4],byte '='
	je fp_20		;jmp if PATH= found
fp_12:
	add ebx,byte 4
	jmp short fp_10
;
; we have found PATH= ,now try each path with our filename
;
fp_20:
  add esi,byte 5		;move past "PATH="
fp_lp2:
  cmp [esi-1],byte 0		;check if end of PATH= entries
  je fp_50
;
; move trial path
;
  mov	edi,executable_path
fp_30:
  lodsb
  stosb
  cmp	al,0
  je	fp_32			;jmp if end of path
  cmp	al,':'
  jne	fp_30			;loop till path moved
fp_32:
  dec	edi
  mov	al,'/'			;append '/' to end of path
  stosb
;
; append our filename to this new path
;
  push esi
  mov esi,ebp		;get pointer to our name
fp_40:
  lodsb
  stosb
  cmp	al,0
  jne	fp_40
  pop esi
;
; get status of this trial path + name
;
  mov	ebx,executable_path
  mov	ecx,fstat_buf
  mov	eax,107			;fstat
  int	80h
  or	eax,eax
  js	fp_lp2			;jmp if file not found
  mov	ax,08040h
  and	ax,[stmode]		;isolate correct fields
  cmp	ax,08040h
  jne	fp_lp2			;keep trying if not executable file
  jmp	short fp_exit		;jmp if executable
;
; none of the PATH= entries worked, try current directiory
;
fp_50:
  mov	esi,default_path
  mov	edi,executable_path
fp_lp3:
  lodsb
  stosb
  cmp	al,0
  jne	fp_lp3			;loop till name moved

  mov	esi,executable_path
  mov	edi,ebp
  call	build_path
;
; try to get status of this file
;
  mov	ebx,executable_path
  mov	ecx,fstat_buf
  mov	eax,107			;fstat
  int	80h
  or	eax,eax
fp_exit:
  ret


;-----------------------------------------------------------------
; build path for execution or open
;  input: edi = filename
;         esi = path base
;
build_path:
  lodsb
  cmp	al,0
  jne	build_path	;loop till end of path
  dec	esi
bp_lp1:
  cmp	byte [esi],'/'
  je	bp_append
  dec	esi
  jmp	short bp_lp1	;scan back till '/' found
bp_append:
  xchg	esi,edi
  inc	edi		;move past '/'
bp_lp2
  lodsb
  stosb
  cmp	al,0
  jne	bp_lp2		;loop till name appended
  ret
  

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - -
;BYTE_TO_HEX_STR - convert hex byte to two ascii characters
;
; inputs:    al = hex byte
;          esi = storage buffer for ascii
;         
; output:   esi = points past last store (bumped by 2)
;* * * * * * * * * * * * * *

BYTE_TO_HEX_STR:
	push	eax
	mov	ah,al		;save for later
	shr	al,1
	shr	al,1
	shr	al,1
	shr	al,1
	call	btha		;convert one nibble
	xchg	ah,al
	call	btha
	pop	eax
	ret
;-----------------------
btha:	and	al,0fh
	add	al,90h		;convert
	daa			;  -al- bits 0-3
	adc	al,40h		;     to hex
	daa			;        ascii
;	cmp	cs:crt_direct,0
;	je	btha_stuff
;	int	29h
;	ret
btha_stuff:	
	mov	byte [esi],al
	inc	esi
	ret	
;--------------------------------
do_ioctl:
	xor	ebx,ebx
	mov	eax,54		;ioctl
	int	0x80
	ret
;-------------------------------
; strout - output string
;  input: ecx - ponter to string
;

strout:
	xor edx, edx
    .count_again:	
	cmp [ecx + edx], byte 0x0
	je .done_count
	inc edx
	jmp .count_again
    .done_count:	
	mov eax, 0x4			; system call 0x4 (write)
	mov ebx, stdout			; file desc. is stdout
	int 0x80
	ret
;*********************************************************************
 [section .data]

ccnt	dd	0
temp	dd	0,0,0,0

msg	db	'file browser',0

kbuf	db	0,0,0,0,0,0,0,0,0,0,0,0


prefix:
	db	"0","x"
bufx	db	0,0,0,0,0,0,0,0
	db	0,0,0,0

exchange_flag	db 	0
window_rows	db	0
window_columns	db	0
window_indent	db	0

winsize:
ws_row:	dw	0
ws_col:	dw	0
ws_xpixel: dw	0
ws_ypixel: dw	0

	
oldtermios:
c_iflag	dd	0
c_oflag dd	0
c_cflag dd	0
c_lflag dd	0
c_line	dd	0
cc_c	db	0,0,0,0,0,0,0,0
	db	0,0,0,0,0,0,0,0
	db	0,0,0


newtermios:
c_iflg dd	0
c_oflg dd	0
c_cflg dd	0
c_lflg dd	0
c_lin	dd	0
c_c	db	0,0,0,0,0,0,0,0
	db	0,0,0,0,0,0,0,0
	db	0,0,0


prog_name_ptr	dd	0	;pointer to our name on stack
enviro_ptrs	dd	0	;pointer to env ptrs on stack

file_path	times 50  db (0)	;user selected file
default_path	times 200 db (0)	;default directory path
executable_path times 200 db (0)	;location of browser
		
fstat_buf
stdev: dd	0
stino: dd 0
stmode: dw 0
stnlink: dw 0
stuid: dw 0
stgid: dw 0
strdev: dd 0
stsize: dd 0
stblksize: dd 0
stblocks: dd 0
statime: dd 0
_unused1: dd 0
stmtime: dd 0
_unused2: dd 0
stctime: dd 0
_unused3: dd 0
_unused4: dd 0
_unused5: dd 0

vt100_cursor
  db	1bh,'['
vt_row
  dw	0		;row
  db	';'
vt_column
  dw	0		;column
  db	'H',0

vt100_color_str
  db	1bh,'['
vcs_atr:
  db	0,'m'
  db	1bh,'[4'
vcs1
  db	0
  db	'm'
  db	1bh,'[3'
vcs2
  db	0
  db	'm'
  db	0
;------------
; colors = aaxxffbb  (aa-attribute ff-foreground  bb-background)
;   30-black 31-red 32-green 33-brown 34-blue 35-purple 36-cyan 37-grey
;   attributes 30-normal 31-bold 34-underscore 37-inverse
file_color	dd 30003730h ;used for inactive window
;			     ;grey-foreground=7 blue-backgound=4 0=norm attr
dir_color	dd 31003130h ;used for active window in edit mode
;			     ;grey-foreground=7 blue-backgound=4 0=bold attr
link_color	dd 31003330h ;used for active window in command mode
;			     ;grey-foreground=7 blue-backgound=4 0=bold attr
status_color	dd 31003330h ;used for active window in command mode
;			     ;grey-foreground=7 blue-backgound=4 0=bold attr
select_color	dd 31003336h ;used for active window in command mode
;			     ;grey-foreground=7 blue-backgound=4 0=bold attr

screenline	times 240 db (0)
page_top_ptr	dd	sort_pointers
select_ptr	dd	sort_pointers 	;- highlighted file name
select_ptr_row	db	1		;  display row for highlighted file

status_msg1 db	'ESC = no selection exit         | select using      ',0
status_msg2 db	'Enter = highlighted/typed name  | up-down-right-left',0
status_msg3 db	'Enter filename :',0

str_max		dd	0	;max string ptr
str_max_count	dd	0	;max characters to input
str_ptr		dd	0	;current string edit point
str_begin	dd	0	;start of string
str_cursor	dd	0	;cursor for string entry, row,column
str_terminator	db	0dh	;terminator for string (1b=esc 0d=return)
char_out	db	0,0,0

old_path	times 40 db (0)

poll_tbl	dd	0	;stdin
		dw	-1	;events of interest
poll_rtn	dw	-1	;return from poll
mouse_escape	db   1bh,"[?1000h",0	;enables mouse reporting

; (#15#) database - buffers *******************************************
;--- unitialized data -------------------------------------

[section .bss]
[bits 32]

; buffer to hold sort pointers
sort_pointers	resd	400	;max directory size
;
; buffer to hold entries in sort format, it overflows into dbuf
;  format is: db - code 0-end 1=dir 2=link 3=file
;             db - asciiz filename
;             db - code
;             db - asciiz filename
sort_buf	resb	9000

;
; raw directory data initially read here.
;  format is: dword - inode
;             dword - offset to next record from top of dbuf
;              word - total bytes in this record
;                db - filename in asciiz format, followed by x zeros
max equ 102400
dbuf resb max

END

